#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>

// bytearray of a zip file with an empty file named 'cosu'
const char empty_zip[] = { 0x50, 0x4b, 0x03, 0x04, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00,
                           0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x63, 0x6f,
                           0x73, 0x75, 0x50, 0x4b, 0x01, 0x02, 0x1e, 0x03, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                           0x21, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00,
                           0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa4, 0x81, 0x00, 0x00, 0x00, 0x00,
                           0x63, 0x6f, 0x73, 0x75, 0x50, 0x4b, 0x05, 0x06, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00,
                           0x32, 0x00, 0x00, 0x00, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00
                         };

int create_empty_zip(char *zipfile)
{
   int fd = open(zipfile, O_CREAT|O_WRONLY|O_TRUNC, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH);
   if (fd == -1)
   {
      perror(zipfile);
      return 1;
   }

   ssize_t w = write(fd, empty_zip, sizeof empty_zip);
   if (w == -1)
   {
      perror(zipfile);
   }
   close(fd);
   return w == -1 ? 1 : 0;
}
